# -*- coding: utf-8 -*-
from setuphelpers import *


def update_package():
    # Declaring local variables
    bin_contains = "windowsdesktop-runtime-"
    package_version = control.get_software_version()
    dotnet_version = ".".join(package_version.split(".")[:2])
    result = False
    proxies = get_proxies()
    if control.architecture != "all":
        archs = [control.architecture]
    else:
        archs = ["x86", "x64"]

    # if not proxies:
    #     proxies = get_proxies_from_wapt_console()
    app_name = control.name

    for arch in archs:
        url_version = "https://versionsof.net/core/%s/" % dotnet_version
        version = wgets(url_version, proxies=proxies).split("Latest runtime:")[1].split("/")[3]
        url = "https://versionsof.net/core/%s/%s/" % (dotnet_version, version)

        # Getting latest version from official sources
        print("URL used is: %s" % url)
        for bs_search in bs_find_all(url, "a", proxies=proxies, timeout=10):
            if bin_contains in bs_search["href"] and arch in bs_search["href"]:
                latest_bin = bs_search["href"].split("/")[-1]
                download_url = bs_search["href"]
                break

        print("Latest %s version is: %s" % (app_name, version))
        print("Download URL is: %s" % download_url)

        # Downloading latest binaries
        if not isfile(latest_bin):
            print("Downloading: %s" % latest_bin)
            wget(download_url, latest_bin, proxies=proxies)

            # Checking version from file
            version_from_file = get_version_from_binary(latest_bin)
            if not version_from_file.startswith(version) and version_from_file != "":
                print("Changing version to the version number of the binary (from: %s to: %s)" % (version, version_from_file))
                os.rename(latest_bin, bin_contains + version_from_file + "-%s.exe" % arch)
                version = version_from_file
            else:
                print("Binary file version corresponds to online version")

    # Changing version of the package
    if Version(version) > Version(control.get_software_version()):
        print("Software version updated (from: %s to: %s)" % (control.get_software_version(), Version(version)))
        result = True
    else:
        print("Software version up-to-date (%s)" % Version(version))
    control.version = "%s-%s" % (Version(version), control.version.split("-", 1)[-1])
    # control.set_software_version(version)
    control.save_control_to_wapt()

    # Deleting outdated binaries
    remove_outdated_binaries(version)

    # Validating or not update-package-sources
    return result
